# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.contact_point import ContactPoint  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501


class ContactDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'name': 'str',
        'telecom': 'list[ContactPoint]',
        'telecom_first_rep': 'ContactPoint',
        'name_element': 'StringType',
        'empty': 'bool',
        'id_element': 'StringType',
        'extension_first_rep': 'Extension',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'name': 'name',
        'telecom': 'telecom',
        'telecom_first_rep': 'telecomFirstRep',
        'name_element': 'nameElement',
        'empty': 'empty',
        'id_element': 'idElement',
        'extension_first_rep': 'extensionFirstRep',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, name=None, telecom=None, telecom_first_rep=None, name_element=None, empty=None, id_element=None, extension_first_rep=None, id_base=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """ContactDetail - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._name = None
        self._telecom = None
        self._telecom_first_rep = None
        self._name_element = None
        self._empty = None
        self._id_element = None
        self._extension_first_rep = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if name is not None:
            self.name = name
        if telecom is not None:
            self.telecom = telecom
        if telecom_first_rep is not None:
            self.telecom_first_rep = telecom_first_rep
        if name_element is not None:
            self.name_element = name_element
        if empty is not None:
            self.empty = empty
        if id_element is not None:
            self.id_element = id_element
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this ContactDetail.  # noqa: E501


        :return: The format_comments_pre of this ContactDetail.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this ContactDetail.


        :param format_comments_pre: The format_comments_pre of this ContactDetail.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this ContactDetail.  # noqa: E501


        :return: The format_comments_post of this ContactDetail.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this ContactDetail.


        :param format_comments_post: The format_comments_post of this ContactDetail.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this ContactDetail.  # noqa: E501


        :return: The id of this ContactDetail.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ContactDetail.


        :param id: The id of this ContactDetail.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this ContactDetail.  # noqa: E501


        :return: The extension of this ContactDetail.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this ContactDetail.


        :param extension: The extension of this ContactDetail.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this ContactDetail.  # noqa: E501


        :return: The disallow_extensions of this ContactDetail.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this ContactDetail.


        :param disallow_extensions: The disallow_extensions of this ContactDetail.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def name(self):
        """Gets the name of this ContactDetail.  # noqa: E501


        :return: The name of this ContactDetail.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ContactDetail.


        :param name: The name of this ContactDetail.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def telecom(self):
        """Gets the telecom of this ContactDetail.  # noqa: E501


        :return: The telecom of this ContactDetail.  # noqa: E501
        :rtype: list[ContactPoint]
        """
        return self._telecom

    @telecom.setter
    def telecom(self, telecom):
        """Sets the telecom of this ContactDetail.


        :param telecom: The telecom of this ContactDetail.  # noqa: E501
        :type: list[ContactPoint]
        """

        self._telecom = telecom

    @property
    def telecom_first_rep(self):
        """Gets the telecom_first_rep of this ContactDetail.  # noqa: E501


        :return: The telecom_first_rep of this ContactDetail.  # noqa: E501
        :rtype: ContactPoint
        """
        return self._telecom_first_rep

    @telecom_first_rep.setter
    def telecom_first_rep(self, telecom_first_rep):
        """Sets the telecom_first_rep of this ContactDetail.


        :param telecom_first_rep: The telecom_first_rep of this ContactDetail.  # noqa: E501
        :type: ContactPoint
        """

        self._telecom_first_rep = telecom_first_rep

    @property
    def name_element(self):
        """Gets the name_element of this ContactDetail.  # noqa: E501


        :return: The name_element of this ContactDetail.  # noqa: E501
        :rtype: StringType
        """
        return self._name_element

    @name_element.setter
    def name_element(self, name_element):
        """Sets the name_element of this ContactDetail.


        :param name_element: The name_element of this ContactDetail.  # noqa: E501
        :type: StringType
        """

        self._name_element = name_element

    @property
    def empty(self):
        """Gets the empty of this ContactDetail.  # noqa: E501


        :return: The empty of this ContactDetail.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this ContactDetail.


        :param empty: The empty of this ContactDetail.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def id_element(self):
        """Gets the id_element of this ContactDetail.  # noqa: E501


        :return: The id_element of this ContactDetail.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this ContactDetail.


        :param id_element: The id_element of this ContactDetail.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this ContactDetail.  # noqa: E501


        :return: The extension_first_rep of this ContactDetail.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this ContactDetail.


        :param extension_first_rep: The extension_first_rep of this ContactDetail.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_base(self):
        """Gets the id_base of this ContactDetail.  # noqa: E501


        :return: The id_base of this ContactDetail.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this ContactDetail.


        :param id_base: The id_base of this ContactDetail.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this ContactDetail.  # noqa: E501


        :return: The resource of this ContactDetail.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this ContactDetail.


        :param resource: The resource of this ContactDetail.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this ContactDetail.  # noqa: E501


        :return: The boolean_primitive of this ContactDetail.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this ContactDetail.


        :param boolean_primitive: The boolean_primitive of this ContactDetail.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this ContactDetail.  # noqa: E501


        :return: The date_time of this ContactDetail.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this ContactDetail.


        :param date_time: The date_time of this ContactDetail.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this ContactDetail.  # noqa: E501


        :return: The primitive of this ContactDetail.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this ContactDetail.


        :param primitive: The primitive of this ContactDetail.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContactDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
